diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/config.c tin-2.6.5/src/config.c
--- tin-2.6.4/src/config.c	2024-12-21 15:16:43.000000000 +0100
+++ tin-2.6.5/src/config.c	2025-12-08 20:05:47.448270994 +0100
@@ -931,9 +974,9 @@ read_config_file(
 			break;
 		}
 	}
-	if (is_7bit) {
+	if (is_7bit)
 		tinrc.mail_mime_encoding = tinrc.post_mime_encoding = MIME_ENCODING_7BIT;
-	} else {
+	else {
 		if (tinrc.mail_mime_encoding == MIME_ENCODING_7BIT)
 			tinrc.mail_mime_encoding = MIME_ENCODING_QP;
 		if (tinrc.post_mime_encoding == MIME_ENCODING_7BIT)
@@ -993,6 +1036,10 @@ read_config_file(
 		FreeIfNeeded(tinrc.page_uue_format);
 		tinrc.page_uue_format = my_strdup(DEFAULT_PAGE_UUE_FORMAT);
 	}
+	if (!tinrc.page_yenc_format || !*tinrc.page_yenc_format) {
+		FreeIfNeeded(tinrc.page_yenc_format);
+		tinrc.page_yenc_format = my_strdup(DEFAULT_PAGE_YENC_FORMAT);
+	}
 
 	return TRUE;
 }
@@ -1022,7 +1069,7 @@ write_config_file(
 		return;
 	}
 
-	wait_message(0, _(txt_saving));
+	wait_message(0, _(txt_saving)); /* TODO: add the filename or remove the message */
 
 	fprintf(fp, txt_tinrc_header, PRODUCT, TINRC_VERSION, tin_progname, VERSION, RELEASEDATE, RELEASENAME);
 
@@ -1157,6 +1204,9 @@ write_config_file(
 	fprintf(fp, "%s", _(txt_add_posted_to_filter.tinrc));
 	fprintf(fp, "add_posted_to_filter=%s\n\n", print_boolean(tinrc.add_posted_to_filter));
 
+	fprintf(fp, "%s", _(txt_keep_expired_filters.tinrc));
+	fprintf(fp, "keep_expired_filters=%s\n\n", print_boolean(tinrc.keep_expired_filters));
+
 	fprintf(fp, "%s", _(txt_sigfile.tinrc));
 	fprintf(fp, "sigfile=%s\n\n", BlankIfNull(tinrc.sigfile));
 
@@ -1196,6 +1246,9 @@ write_config_file(
 	fprintf(fp, "quote_regex2=%s\n\n", BlankIfNull(tinrc.quote_regex2));
 	fprintf(fp, "%s", _(txt_quote_regex3.tinrc));
 	fprintf(fp, "quote_regex3=%s\n\n", BlankIfNull(tinrc.quote_regex3));
+
+	fprintf(fp, "%s", _(txt_extquote_regex.tinrc));
+	fprintf(fp, "extquote_regex=%s\n\n", BlankIfNull(tinrc.extquote_regex));
 #endif /* HAVE_COLOR */
 
 	fprintf(fp, "%s", _(txt_slashes_regex.tinrc));
@@ -1217,10 +1270,8 @@ write_config_file(
 	fprintf(fp, "%s", _(txt_verbatim_end_regex.tinrc));
 	fprintf(fp, "verbatim_end_regex=%s\n\n", BlankIfNull(tinrc.verbatim_end_regex));
 
-#ifdef HAVE_COLOR
-	fprintf(fp, "%s", _(txt_extquote_regex.tinrc));
-	fprintf(fp, "extquote_regex=%s\n\n", BlankIfNull(tinrc.extquote_regex));
-#endif /* HAVE_COLOR */
+	fprintf(fp, "%s", _(txt_hideline_regex.tinrc));
+	fprintf(fp, "hideline_regex=%s\n\n", (*tinrc.hideline_regex && STRCMPEQ(tinrc.hideline_regex, NEVER_MATCH_REGEX)) ? "" : BlankIfNull(tinrc.hideline_regex));
 
 	fprintf(fp, "%s", _(txt_show_signatures.tinrc));
 	fprintf(fp, "show_signatures=%s\n\n", print_boolean(tinrc.show_signatures));
@@ -1236,8 +1287,8 @@ write_config_file(
 	fprintf(fp, "%s", _(txt_tex2iso_conv.tinrc));
 	fprintf(fp, "tex2iso_conv=%s\n\n", print_boolean(tinrc.tex2iso_conv));
 
-	fprintf(fp, "%s", _(txt_hide_uue.tinrc));
-	fprintf(fp, "hide_uue=%d\n\n", tinrc.hide_uue);
+	fprintf(fp, "%s", _(txt_hide_inline_data.tinrc));
+	fprintf(fp, "hide_inline_data=%d\n\n", tinrc.hide_inline_data);
 
 	fprintf(fp, "%s", _(txt_news_quote_format.tinrc));
 	fprintf(fp, "news_quote_format=%s\n", BlankIfNull(tinrc.news_quote_format));
@@ -1279,6 +1330,18 @@ write_config_file(
 	fprintf(fp, "%s", _(txt_art_marked_read_selected.tinrc));
 	fprintf(fp, "art_marked_read_selected=%"T_CHAR_FMT"\n\n", SPACE_TO_DASH(tinrc.art_marked_read_selected));
 
+	fprintf(fp, "%s", _(txt_scope_marked_global.tinrc));
+	fprintf(fp, "scope_marked_global=%"T_CHAR_FMT"\n\n", SPACE_TO_DASH(tinrc.scope_marked_global));
+
+	fprintf(fp, "%s", _(txt_scope_marked_global_match.tinrc));
+	fprintf(fp, "scope_marked_global_match=%"T_CHAR_FMT"\n\n", SPACE_TO_DASH(tinrc.scope_marked_global_match));
+
+	fprintf(fp, "%s", _(txt_scope_marked_local.tinrc));
+	fprintf(fp, "scope_marked_local=%"T_CHAR_FMT"\n\n", SPACE_TO_DASH(tinrc.scope_marked_local));
+
+	fprintf(fp, "%s", _(txt_scope_marked_local_match.tinrc));
+	fprintf(fp, "scope_marked_local_match=%"T_CHAR_FMT"\n\n", SPACE_TO_DASH(tinrc.scope_marked_local_match));
+
 	fprintf(fp, "%s", _(txt_force_screen_redraw.tinrc));
 	fprintf(fp, "force_screen_redraw=%s\n\n", print_boolean(tinrc.force_screen_redraw));
 
@@ -1316,10 +1379,10 @@ write_config_file(
 	fprintf(fp, "%s", _(txt_cache_overview_files.tinrc));
 	fprintf(fp, "cache_overview_files=%s\n\n", print_boolean(tinrc.cache_overview_files));
 
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 	fprintf(fp, "%s", _(txt_compress_overview_files.tinrc));
 	fprintf(fp, "compress_overview_files=%s\n\n", print_boolean(tinrc.compress_overview_files));
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* USE_ZLIB */
 
 	fprintf(fp, "%s", _(txt_getart_limit.tinrc));
 	fprintf(fp, "getart_limit=%d\n\n", tinrc.getart_limit);
@@ -1503,7 +1566,7 @@ write_config_file(
 	fprintf(fp, "alternative_handling=%s\n\n", print_boolean(tinrc.alternative_handling));
 
 	fprintf(fp, "%s", _(txt_verbatim_handling.tinrc));
-	fprintf(fp, "verbatim_handling=%s\n\n", print_boolean(tinrc.verbatim_handling));
+	fprintf(fp, "verbatim_handling=%d\n\n", tinrc.verbatim_handling);
 
 #ifdef HAVE_COLOR
 	fprintf(fp, "%s", _(txt_extquote_handling.tinrc));
@@ -1537,6 +1600,9 @@ write_config_file(
 	fprintf(fp, "%s", _(txt_page_uue_format.tinrc));
 	fprintf(fp, "page_uue_format=%s\n\n", BlankIfNull(tinrc.page_uue_format));
 
+	fprintf(fp, "%s", _(txt_page_yenc_format.tinrc));
+	fprintf(fp, "page_yenc_format=%s\n\n", BlankIfNull(tinrc.page_yenc_format));
+
 	fprintf(fp, "%s", _(txt_date_format.tinrc));
 	fprintf(fp, "date_format=%s\n\n", BlankIfNull(tinrc.date_format));
 
@@ -1607,6 +1673,7 @@ write_config_file(
 		for (i = 0; i < num_newnews; i++) {
 			if (i == j)
 				continue;
+
 			if (my_strftime(timestring, sizeof(timestring) - 1, "%Y-%m-%d %H:%M:%S UTC", gmtime(&(newnews[i].time))))
 				fprintf(fp, "newnews=%s %lu (%s)\n", newnews[i].host, (unsigned long int) newnews[i].time, timestring);
 		}
@@ -1636,7 +1703,7 @@ write_config_file(
 
 t_bool
 match_boolean(
-	char *line,
+	const char *line,
 	const char *pat,
 	t_bool *dst)
 {
@@ -1672,7 +1739,7 @@ match_color(
 		}
 
 		if (!found)
-			*dst = atoi(&line[patlen]);
+			*dst = strtol(&line[patlen], NULL, 10);
 
 		if (max) {
 			if (max == MAX_BACKCOLOR && *dst > max && *dst <= MAX_COLOR)
@@ -1708,7 +1775,7 @@ match_integer(
 	size_t patlen = strlen(pat);
 
 	if (STRNCMPEQ(line, pat, patlen)) {
-		*dst = atoi(&line[patlen]);
+		*dst = strtol(&line[patlen], NULL, 10);
 
 		if (maxval) {
 			if ((*dst < 0) || (*dst > maxval)) {
@@ -1748,7 +1815,7 @@ match_long(
  */
 t_bool
 match_list(
-	char *line,
+	const char *line,
 	constext *pat,
 	constext *const *table,
 	int *dst)
@@ -1775,7 +1842,7 @@ match_list(
 
 t_bool
 match_string(
-	char *line,
+	const char *line,
 	const char *pat,
 	char *dst,
 	size_t dstlen)
@@ -1793,7 +1860,7 @@ match_string(
 
 t_bool
 match_string_ptr(
-	char *line,
+	const char *line,
 	const char *pat,
 	char **dst)
 {
@@ -1829,7 +1896,8 @@ match_item(
 
 	if (!strcasecmp(nline, pat)) {
 		if (dst != NULL) {
-			strncpy(dst, &nline[strlen(pat)], dstlen);
+			if (dstlen)
+				strncpy(dst, &nline[strlen(pat)], dstlen - 1);
 			dst[dstlen ? (dstlen - 1) : 0] = '\0';
 		}
 		free(nline);
@@ -1902,7 +1970,7 @@ ulBuildArgv(
 	const char *cmd,
 	int *new_argc)
 {
-	char **new_argv = NULL;
+	char **new_argv;
 	char *buf, *tmp;
 	const char *tmp_cmd;
 	int i = 0;
@@ -1925,17 +1993,18 @@ ulBuildArgv(
 			new_argv[i] = tmp;
 			for (; *tmp && !isspace((unsigned char) *tmp); tmp++)
 				;
-			if (*tmp) {
-				*tmp = '\0';
-				++tmp;
-			}
+			if (*tmp)
+				*tmp++ = '\0';
 			++i;
 			new_argv = my_realloc(new_argv, ((size_t) (i + 1) * sizeof(char *)));
 			new_argv[i] = NULL;
 		} else
 			++tmp;
 	}
-	*new_argc = i;
+	if ((*new_argc = i) == 0) {
+		free(buf);
+		FreeAndNull(new_argv);
+	}
 	return new_argv;
 }
 
@@ -1956,7 +2025,6 @@ rc_update(
 	t_bool confirm_action = FALSE;
 	t_bool compress_quotes = FALSE;
 	t_bool set_goto_next_unread = FALSE;
-	t_bool hide_uue = FALSE;
 	t_bool keep_posted_articles = FALSE;
 	t_bool pgdn_goto_next = FALSE;
 	t_bool quote_empty_lines = FALSE;
@@ -1985,7 +2053,6 @@ rc_update(
 			case 'a':
 				if (match_boolean(buf, "auto_bcc=", &auto_bcc))
 					break;
-
 				if (match_boolean(buf, "auto_cc=", &auto_cc))
 					break;
 				break;
@@ -2039,7 +2106,7 @@ rc_update(
 					if (*tinrc.sigfile == '!' && (tinrc.sigfile[l - 2] != '%' || tinrc.sigfile[l - 1] != 'G')) {
 						char *newbuf = my_malloc(sizeof(tinrc.sigfile) + 4);
 
-						sprintf(newbuf, "%s %s", tinrc.sigfile, "%G");
+						sprintf(newbuf, "%s %%G", tinrc.sigfile);
 						free(tinrc.sigfile);
 						tinrc.sigfile = my_strdup(newbuf);
 						free(newbuf);
@@ -2048,11 +2115,6 @@ rc_update(
 				}
 				break;
 
-			case 'h':
-				if (match_boolean(buf, "hide_uue=", &hide_uue))
-					break;
-				break;
-
 			case 'k':
 				if (match_boolean(buf, "keep_posted_articles=", &keep_posted_articles))
 					break;
@@ -2134,9 +2196,6 @@ rc_update(
 			tinrc.goto_next_unread |= GOTO_NEXT_UNREAD_TAB;
 	}
 
-	if (hide_uue)
-		tinrc.hide_uue = 1;
-
 	if (keep_posted_articles) {
 		FreeIfNeeded(tinrc.posted_articles_file);
 		tinrc.posted_articles_file = my_strdup(POSTED_FILE);
@@ -2186,10 +2245,12 @@ rc_update(
 	if (use_mailreader_i)
 		tinrc.interactive_mailer = INTERACTIVE_WITHOUT_HEADERS;
 
-	if (!use_metamail || getenv("NOMETAMAIL") != NULL)
-		tinrc.metamail_prog = my_strdup(INTERNAL_CMD);
-	else
-		tinrc.metamail_prog = my_strdup(METAMAIL_CMD);
+	if (!*tinrc.metamail_prog) {
+		if (!use_metamail || getenv("NOMETAMAIL") != NULL)
+			tinrc.metamail_prog = my_strdup(INTERNAL_CMD);
+		else
+			tinrc.metamail_prog = my_strdup(METAMAIL_CMD);
+	}
 
 	rewind(fp);
 	return TRUE;
@@ -2206,14 +2267,15 @@ rc_update(
  */
 static t_bool
 rc_post_update(
-	FILE *fp
-	/* , struct t_version *upgrade */)
+	FILE *fp,
+	const struct t_version *upgrade)
 {
 	char *buf;
 	int groupname_max_length = 0;
+	t_bool verbatim_handling = TRUE;
 
 	if (fseek(fp, 0L, SEEK_SET) == -1) {
-		perror_message(txt_error_fseek, fp);
+		perror_message(txt_error_fseek);
 		return FALSE;
 	}
 
@@ -2242,6 +2304,24 @@ rc_post_update(
 
 				break;
 
+			case 'h':
+				if (upgrade && upgrade->file_version <= 10305) {
+					t_bool hide_uue;
+
+					if (match_boolean(buf, "hide_uue=", &hide_uue)) {
+						if (hide_uue)
+							tinrc.hide_inline_data = 1;
+						break;
+					}
+				} else {
+					if (match_integer(buf, "hide_uue=", &tinrc.hide_inline_data, HIDE_ALL)) {
+						if (tinrc.hide_inline_data & UUE_INCOMPL)
+							tinrc.hide_inline_data &= ~UUE_YES;
+						break;
+					}
+				}
+				break;
+
 			case 's':
 				/*
 				 * previous versions has always passed groupname to external
@@ -2253,7 +2333,7 @@ rc_post_update(
 					if (tinrc.sigfile[0] == '!' && (tinrc.sigfile[l - 2] != '%' || tinrc.sigfile[l - 1] != 'G')) {
 						char *newbuf = my_malloc(sizeof(tinrc.sigfile) + 4);
 
-						sprintf(newbuf, "%s %s", tinrc.sigfile, "%G");
+						sprintf(newbuf, "%s %%G", tinrc.sigfile);
 						my_strncpy(tinrc.sigfile, newbuf, sizeof(tinrc.sigfile) - 1);
 						free(newbuf);
 					}
@@ -2261,6 +2341,12 @@ rc_post_update(
 				}
 				break;
 
+			case 'v':
+				/* verbatim_handling has changed from bool to int in TINRC_VERSION == 1.3.19 */
+				if (upgrade && upgrade->file_version < 10319 && match_boolean(buf, "verbatim_handling=", &verbatim_handling))
+					break;
+				break;
+
 			default:
 				break;
 		}
@@ -2290,72 +2376,381 @@ rc_post_update(
 		free(dest);
 	}
 
+	/* verbatim_handling has changed from bool to int in TINRC_VERSION == 1.3.19 */
+	if (upgrade && upgrade->file_version < 10319)
+		tinrc.verbatim_handling = verbatim_handling ? VERBATIM_SHOW_ALL : VERBATIM_NONE;
+
 	return TRUE;
 }
 
 
+/*
+ * NOTE: this is read after the cmd-line options and
+ *       after glocal/local-tinrc, so add_cmd_line_opts
+ *       may override them, but be aware that attributes
+ *       are read even later (so better not add anything
+ *       which could also be set via attributes to avoid
+ *       confusion).
+ *
+ * TODO: - add more server specific vars (which can't be set
+ *         via add_cmd_line_opts e.g. strip_newsrc) or even per
+ *         server config-files like keymap, filter, ...?
+ *       - add a cmd-line option to skip reading the serverrc?
+ *         (what about status vars like last_newnews or motd_hash then?)
+ */
+#if defined(NNTP_ABLE) && defined(INET6)
+#	define USELESS_COMB(keep,ignore) do { \
+		wait_message(2, _(txt_useless_combination), keep, ignore, ignore, _(txt_keeping_add_cmd_line_opts)); \
+	} while (0)
+#endif /* NNTP_ABLE && INET6 */
+/* avoid to add options which take a string as argument */
+#define ADD_CMD_OPTIONS ":46ACdG:knp:qQt:Tx"
 void
 read_server_config(
-	void)
+	unsigned int option_mask) /* -u or -R on the cmd.-line? */
 {
 	FILE *fp;
 	char *line;
-	char file[PATH_LEN];
+	char *d, *s, *bp = NULL;
 	char newnews_info[LEN];
-	char serverdir[PATH_LEN];
+	int i;
 	struct t_version *upgrade = NULL;
-
 #ifdef NNTP_ABLE
-	if (read_news_via_nntp && !read_saved_news && nntp_tcp_port != IPPORT_NNTP)
-		snprintf(file, sizeof(file), "%s:%u", nntp_server, nntp_tcp_port);
-	else
+	const char *valid_suppressions[] = { /* keep in sync with check_extensions() */
+		"AUTHINFO SASL",
+		"CAPABILITIES",
+		"COMPRESS DEFLATE",
+		"HDR",
+		"LIST COUNTS",
+		"LIST DISTRIB.PATS",
+		"LIST DISTRIBUTIONS",
+		"LIST HEADERS",
+		"LIST MOTD",
+		"LIST NEWSGROUPS",
+		"LIST OVERVIEW.FMT",
+		"LIST SUBSCRIPTIONS",
+		"LISTGROUP",
+		"NEWGROUPS",
+		"NEXT",
+		"OVER",
+		"XHDR",
+		"XOVER",
+		"XPAT",
+		NULL
+	};
+	t_bool is_valid;
 #endif /* NNTP_ABLE */
-	{
-		STRCPY(file, quote_space_to_dash(nntp_server));
-	}
-	joinpath(serverdir, sizeof(serverdir), rcdir, file);
-	joinpath(file, sizeof(file), serverdir, SERVERCONFIG_FILE);
+
+	/*
+	 * to avoid !serverrc.disabled_nntp_cmds checks elsewhere
+	 * this is for the case when we can't read the serverrc
+	 */
+	serverrc.disabled_nntp_cmds = my_strdup("");
+
+	/*
+	 * as we don't want to logical OR to but override
+	 * tinrc values pull them in as default first
+	 */
+	serverrc.cache_overview_files = tinrc.cache_overview_files;
+#ifdef USE_ZLIB
+	serverrc.compress_overview_files = tinrc.compress_overview_files;
+#endif /* USE_ZLIB */
+
 	joinpath(local_newsgroups_file, sizeof(local_newsgroups_file), serverdir, NEWSGROUPS_FILE);
 	joinpath(local_motd_file, sizeof(local_motd_file), serverdir, MOTD_FILE);
 
-	if ((fp = tin_fopen(file, "r")) == NULL)
+	if ((fp = tin_fopen(serverrc_file, "r")) == NULL)
 		return;
 
 	while ((line = tin_fgets(fp, FALSE)) != NULL) {
-		if ((*line == '#') || (*line == '\0'))
+		if (*line == '#' || *line == '\0')
 			continue;
 
-		if (match_string(line, "last_newnews=", newnews_info, sizeof(newnews_info))) {
-			char *tmp_info;
-			int tmp_len;
+		/*
+		 * serverrc specific
+		 */
+		if (match_string_ptr(line, "add_cmd_line_opts=", &serverrc.add_cmd_line_opts)) {
+			str_trim(serverrc.add_cmd_line_opts);
+			continue; /* parsing is done after the file has been read */
+		}
+
+		/*
+		 * we intentionally read them even in the !NNTP_ABLE case
+		 * but do no checking then
+		 */
+		if (match_string(line, "disabled_nntp_cmds=", NULL, 0)) {
+			FreeAndNull(serverrc.disabled_nntp_cmds);
+			/* to avoid !serverrc.disabled_nntp_cmds checks elsewhere */
+			serverrc.disabled_nntp_cmds = my_strdup("");
+			/* beautify */
+			s = line + strlen("disabled_nntp_cmds=");
+			while ((d = strtok(s, ",")) != NULL) {
+				str_trim(d);
+#ifdef NNTP_ABLE
+				i = 0;
+				is_valid = FALSE;
+				if (*d == '"')
+					++d;
+				if (*d && d[strlen(d) - 1] == '"')
+					d[strlen(d) - 1] = '\0';
+				str_trim(d);
+				buffer_to_ascii(d);
+				str_upr(d);
+				while (!is_valid && valid_suppressions[i]) {
+					if (!strcmp(d, valid_suppressions[i++]))
+						is_valid = TRUE;
+				}
+#endif /* NNTP_ABLE */
 
-			if ((tmp_len = snprintf(NULL, 0, "%s %s", nntp_server, newnews_info)) > 0) {
-				tmp_info = my_malloc(++tmp_len);
-				if (snprintf(tmp_info, (size_t) tmp_len, "%s %s", nntp_server, newnews_info) == tmp_len - 1)
-					load_newnews_info(tmp_info);
-				free(tmp_info);
+				if (*d) { /* ignore empty tokens */
+#ifdef NNTP_ABLE
+					if (!is_valid)
+						wait_message(3, _(txt_invalid_disabled_nntp_cmds), d);
+					else
+#endif /* NNTP_ABLE */
+					{
+						bp = append_to_string(bp, d);
+						bp = append_to_string(bp, ",");
+#ifdef NNTP_ABLE
+						/*
+						 * special case, everything else is handled in
+						 * check_extensions() (after add_cmd_line_opts has
+						 * been parsed)
+						 */
+						if (nntp_caps.type != BROKEN && !strcmp(d, "CAPABILITIES"))
+							nntp_caps.type = BROKEN;
+#endif /* NNTP_ABLE */
+					}
+				}
+				s = NULL;
+			}
+			if (bp && *bp) {
+				i = strlen(bp);
+				if (*(bp + i - 1) == ',')
+					*(bp + i - 1) = '\0';
+				serverrc.disabled_nntp_cmds = append_to_string(serverrc.disabled_nntp_cmds, bp);
 			}
+			FreeAndNull(bp);
+
 			continue;
 		}
 
-		if (match_long(line, "motd_hash=", &motd_hash))
+		/* per server -DDISABLE_PIPELINING, >=2 allow piplelining */
+		if (match_integer(line, "nntp_pipeline_limit=", &serverrc.nntp_pipeline_limit, 0)) { /* we intentionally don't give the upper limit here */
+			if (serverrc.nntp_pipeline_limit < PIPELINE_LIMIT_MIN)
+				serverrc.nntp_pipeline_limit = PIPELINE_LIMIT_MIN;
+			else { /* upper limit */
+				if (serverrc.nntp_pipeline_limit > PIPELINE_LIMIT_MAX)
+					serverrc.nntp_pipeline_limit = PIPELINE_LIMIT_MAX;
+			}
+			continue;
+		}
+
+		/*
+		 * tinrc overrides
+		 */
+		if (match_boolean(line, "cache_overview_files=", &serverrc.cache_overview_files))
+			continue;
+
+#ifdef USE_ZLIB
+		if (match_boolean(line, "compress_overview_files=", &serverrc.compress_overview_files))
+			continue;
+#endif /* USE_ZLIB */
+
+		/*
+		 * internal values
+		 */
+		if (match_long(line, "motd_hash=", &serverrc.motd_hash))
+			continue;
+
+		if (match_string(line, "last_newnews=", newnews_info, sizeof(newnews_info))) {
+			if ((i = snprintf(NULL, 0, "%s %s", nntp_server, newnews_info)) > 0) {
+				s = my_malloc(++i);
+				if (snprintf(s, (size_t) i, "%s %s", nntp_server, newnews_info) == i - 1)
+					load_newnews_info(s);
+				free(s);
+			}
 			continue;
+		}
 
 		if (match_string(line, "version=", NULL, 0)) {
 			if (upgrade != NULL) /* ignore duplicate version lines; first match counts */
 				continue;
 
 			upgrade = check_upgrade(line, "version=", SERVERCONFIG_VERSION);
-			if (upgrade->state == RC_IGNORE) /* Expected version number; nothing to do -> continue */
-				continue;
+			if (upgrade->state != RC_IGNORE)
+				upgrade_prompt_quit(upgrade, serverrc_file, fp);
 
 			/* Nothing to do yet for RC_UPGRADE and RC_DOWNGRADE */
 			continue;
 		}
 	}
+
+	/*
+	 * parse serverrc.add_cmd_line_opts here so we can override options
+	 * in the file
+	 */
+	if (serverrc.add_cmd_line_opts && *serverrc.add_cmd_line_opts) {
+		char *args[LEN];
+		char *token, *lc = NULL;
+		int ch;
+
+		/* prepare args for getopt() with dummy args[0] */
+		lc = append_to_string(lc, "serverrc.add_cmd_line_opts ");
+		lc = append_to_string(lc, serverrc.add_cmd_line_opts);
+		/*
+		 * we split on \s without any extra checks for quoting here
+		 * that's ok as long as we don't allow any options which take
+		 * a string as argument ...
+		 */
+		token = strtok(lc, " \t");
+		i = 0;
+		while (token != NULL && i < LEN - 1) {
+			args[i++] = token;
+			token = strtok(NULL, " \t");
+		}
+		args[i] = NULL;
+		optind = 1;
+		optopt = 0; /* AFAIK at least MINIX < 3.2.0 doesn't set optopt */
+
+		while ((ch = getopt(i, args, ADD_CMD_OPTIONS)) != -1) {
+			switch (ch) {
+				case '4':
+#if defined(NNTP_ABLE) && defined(INET6)
+					if (force_ipv6) {
+						USELESS_COMB("-4", "-6");
+					}
+					read_news_via_nntp = force_ipv4 = TRUE;
+					force_ipv6 = FALSE;
+#endif /* NNTP_ABLE && INET6 */
+					break;
+
+				case '6':
+#if defined(NNTP_ABLE) && defined(INET6)
+					if (force_ipv4) {
+						USELESS_COMB("-6", "-4");
+					}
+					read_news_via_nntp = force_ipv6 = TRUE;
+					force_ipv4 = FALSE;
+#endif /* NNTP_ABLE && INET6 */
+					break;
+
+				case 'A':
+#ifdef NNTP_ABLE
+					read_news_via_nntp = force_auth_on_conn_open = TRUE;
+#endif /* NNTP_ABLE */
+					break;
+
+				case 'C':
+#if defined(NNTP_ABLE) && defined(USE_ZLIB)
+					read_news_via_nntp = use_compress = TRUE;
+#endif /* NNTP_ABLE && USE_ZLIB */
+					break;
+
+				case 'd':
+					show_description = FALSE;
+					cmdline.args |= CMDLINE_NO_DESCRIPTION;
+					break;
+
+				case 'G':
+					if ((option_mask & SRVRC_MASK_UPDATE_INDEX) != SRVRC_MASK_UPDATE_INDEX) { /* only accept -G without -u */
+						cmdline.getart_limit = s2i(optarg, INT_MIN, INT_MAX);
+						if (errno)
+							cmdline.getart_limit = 0;
+						if (cmdline.getart_limit != 0)
+							cmdline.args |= CMDLINE_GETART_LIMIT;
+					}
+					break;
+
+				case 'k':
+#ifdef NNTPS_ABLE
+					read_news_via_nntp = insecure_nntps = use_nntps = TRUE;
+#endif /* NNTPS_ABLE */
+					break;
+
+				case 'n':
+					newsrc_active = TRUE;
+					list_active = FALSE;
+					break;
+
+				case 'p':
+#ifdef NNTP_ABLE
+					nntp_tcp_port = (unsigned short) s2i(optarg, 0, 65535);
+					if (errno)
+						nntp_tcp_port = IPPORT_NNTP;
+					read_news_via_nntp = TRUE;
+#endif /* NNTP_ABLE */
+					break;
+
+				case 'q':
+					check_for_new_newsgroups = FALSE;
+					break;
+
+				case 'Q':
+					newsrc_active = TRUE;
+					list_active = FALSE;
+					check_for_new_newsgroups = FALSE;
+					show_description = FALSE;
+					cmdline.args |= CMDLINE_NO_DESCRIPTION;
+					break;
+
+				case 't':
+#if defined(NNTP_ABLE) && defined(HAVE_ALARM) && defined(SIGALRM)
+					if ((option_mask & SRVRC_MASK_READ_SAVED_NEWS) != SRVRC_MASK_READ_SAVED_NEWS) {
+						cmdline.nntp_timeout = s2i(optarg, 0, TIN_NNTP_TIMEOUT_MAX);
+						if (errno)
+							cmdline.nntp_timeout = 120;
+						if (cmdline.nntp_timeout)
+							cmdline.args |= CMDLINE_NNTP_TIMEOUT;
+						read_news_via_nntp = TRUE;
+					}
+#endif /* NNTP_ABLE && HAVE_ALARM && SIGALRM */
+					break;
+
+				case 'T':
+#ifdef NNTPS_ABLE
+					read_news_via_nntp = use_nntps = TRUE;
+					if (nntp_tcp_port == nntp_tcp_default_port) /* TODO: a previous -p has precedence, logic ok? */
+						nntp_tcp_port = nntps_tcp_default_port;
+#endif /* NNTPS_ABLE */
+					break;
+
+				case 'x':
+					force_no_post = TRUE;
+					break;
+
+				case ':':
+					if (optopt)
+						error_message(2, _(txt_error_option_missing_argument), "serverrc.add_cmd_line_opts", optopt);
+					break;
+
+				case '?':
+				default:
+					if (optopt)
+						error_message(2, _(txt_error_option_unknown), "serverrc.add_cmd_line_opts", optopt);
+					break;
+			}
+		}
+		free(lc);
+	}
 	fclose(fp);
 	FreeAndNull(upgrade);
+
+	/* init tinrc.serverrc_* */
+	if (serverrc.add_cmd_line_opts)
+		tinrc.serverrc_add_cmd_line_opts = my_strdup(serverrc.add_cmd_line_opts);
+	if (serverrc.disabled_nntp_cmds)
+		tinrc.serverrc_disabled_nntp_cmds = my_strdup(serverrc.disabled_nntp_cmds);
+	tinrc.serverrc_nntp_pipeline_limit = serverrc.nntp_pipeline_limit;
+	tinrc.serverrc_cache_overview_files = serverrc.cache_overview_files;
+#ifdef USE_ZLIB
+	tinrc.serverrc_compress_overview_files = serverrc.compress_overview_files;
+#endif /* USE_ZLIB */
 }
+#undef ADD_CMD_OPTIONS
+#if defined(NNTP_ABLE) && defined(INET6)
+#	undef USELESS_COMB
+#endif /* NNTP_ABLE && INET6 */
 
 
 static void
@@ -2365,27 +2760,14 @@ write_server_config(
 	DIR *dirp;
 	FILE *fp;
 	char *file_tmp;
-	char file[PATH_LEN];
 	char timestring[30];
-	char serverdir[PATH_LEN];
 	int i;
 
 	if (read_saved_news)
 		/* don't update server files while reading locally stored articles */
 		return;
 
-#ifdef NNTP_ABLE
-	if (read_news_via_nntp && nntp_tcp_port != IPPORT_NNTP)
-		snprintf(file, sizeof(file), "%s:%u", nntp_server, nntp_tcp_port);
-	else
-#endif /* NNTP_ABLE */
-	{
-		STRCPY(file, nntp_server);
-	}
-	joinpath(serverdir, sizeof(serverdir), rcdir, file);
-	joinpath(file, sizeof(file), serverdir, SERVERCONFIG_FILE);
-
-	if ((no_write || post_article_and_exit || post_postponed_and_exit) && file_size(file) != -1L)
+	if ((no_write || post_article_and_exit || post_postponed_and_exit) && file_size(serverrc_file) != -1L)
 		return;
 
 	errno = 0;
@@ -2407,7 +2789,7 @@ write_server_config(
 		CLOSEDIR(dirp);
 
 	/* generate tmp-filename */
-	if ((file_tmp = get_tmpfilename(file)) == NULL)
+	if ((file_tmp = get_tmpfilename(serverrc_file)) == NULL)
 		return;
 
 	if ((fp = fopen(file_tmp, "w")) == NULL) {
@@ -2419,9 +2801,20 @@ write_server_config(
 	fprintf(fp, _(txt_serverconfig_header), PRODUCT, tin_progname, VERSION, RELEASEDATE, RELEASENAME, PRODUCT, PRODUCT);
 	fprintf(fp, "version=%s\n", SERVERCONFIG_VERSION);
 
-	if (motd_hash != 0)
-		fprintf(fp, "motd_hash=%lu\n", (unsigned long int) motd_hash);
-
+	fprintf(fp, "%s", _(txt_serverrc_config_opts));
+	fprintf(fp, "add_cmd_line_opts=%s\n", BlankIfNull(serverrc.add_cmd_line_opts));
+	fprintf(fp, "disabled_nntp_cmds=%s\n", BlankIfNull(serverrc.disabled_nntp_cmds));
+	fprintf(fp, "nntp_pipeline_limit=%d\n", serverrc.nntp_pipeline_limit);
+
+	fprintf(fp, "%s", _(txt_serverrc_tinrc));
+	fprintf(fp, "cache_overview_files=%s\n", print_boolean(serverrc.cache_overview_files));
+#ifdef USE_ZLIB
+	fprintf(fp, "compress_overview_files=%s\n", print_boolean(serverrc.compress_overview_files));
+#endif /* USE_ZLIB */
+
+	fprintf(fp, "%s", _(txt_serverrc_internal));
+	if (serverrc.motd_hash != 0L)
+		fprintf(fp, "motd_hash=%lu\n", (unsigned long int) serverrc.motd_hash);
 	if ((i = find_newnews_index(nntp_server)) >= 0) {
 		if (my_strftime(timestring, sizeof(timestring) - 1, "%Y-%m-%d %H:%M:%S UTC", gmtime(&(newnews[i].time))))
 			fprintf(fp, "last_newnews=%lu (%s)\n", (unsigned long int) newnews[i].time, timestring);
@@ -2442,7 +2835,7 @@ write_server_config(
 			fclose(fp);
 		}
 	} else
-		rename_file(file_tmp, file);
+		rename_file(file_tmp, serverrc_file);
 
 	free(file_tmp);
 }
